﻿Imports Newtonsoft.Json.Linq
Imports RestSharp
Imports System
Imports System.Collections.Generic

Public Class StockHistoryRetriever
    Private Const API_TOKEN As String = "<YOUR PUBLISHABLE API TOKEN>"
    Private Const BASE_URL As String = "https://cloud.iexapis.com"
    Private Const API_VERSION As String = "beta"

    Public Function Get3MonthHistory(ByVal symbols As List(Of String)) As List(Of ClosingStockHistory)
        Dim client = New RestClient(BASE_URL)
        Dim endpoint = $"{API_VERSION}/stock/market/batch"
        Dim request = New RestRequest(endpoint, Method.Get)
        request.AddQueryParameter("symbols", String.Join(",", symbols))
        request.AddQueryParameter("types", "chart")
        request.AddQueryParameter("range", "3m")
        request.AddQueryParameter("chartCloseOnly", "true")
        request.AddQueryParameter("token", API_TOKEN)

        Dim resp As RestResponse = client.Execute(request)
        Dim stockHistory = JObject.Parse(resp.Content)
        Dim history = New List(Of ClosingStockHistory)
        For Each symbol In symbols
            If symbol = "" Then Continue For
            Dim closingStockHistory = New ClosingStockHistory()
            closingStockHistory.Symbol = symbol
            closingStockHistory.Prices = New List(Of ClosingPrice)
            Dim stock = stockHistory(symbol)
            Dim chartData = CType(stock("chart"), JArray)
            For Each itm In chartData
                closingStockHistory.Prices.Add(New ClosingPrice() With {.ClosingDate = Convert.ToDateTime(itm("date")), .Price = Convert.ToDouble(itm("close"))})
                history.Add(closingStockHistory)
            Next
        Next
        Return history
    End Function

End Class

Public Class ClosingStockHistory
    Public Property Symbol As String
    Public Property Prices As List(Of ClosingPrice)
End Class

Public Class ClosingPrice
    Public Property ClosingDate As Date
    Public Property Price As Double
End Class
